from sqlite_utils import Database


def statutes(db: Database) -> Database:
    if not db["Statutes"].exists():
        db["Statutes"].create(
            columns={
                "date_approved": str,
                "category_num": int,
                "category": str,
                "numeral": str,
                "numeric_title": str,
                "official_title": str,
                "origin": str,
                "publication": str,
                "enacting_clause": str,
                "first_section": str,
                "signatory_content": str,
                "date_scraped": str,
                "date_updated": str,
                "body_statute": str,
            },
            pk="id",
        )
    return db


def containers(db: Database) -> Database:
    if not db["Containers"].exists():
        db["Containers"].create(
            columns={
                "container_id": str,
                "statute_id": int,
                "component": str,
                "label": str,
            },
            pk="id",
            column_order=(
                "id",
                "container_id",
                "statute_id",
                "component",
                "label",
            ),
            foreign_keys=["statute_id"],
        )
    return db


def units(db: Database) -> Database:
    if not db["Units"].exists():
        db["Units"].create(
            columns={
                "unit": str,
                "container": int,
                "order": int,
                "statute_id": int,
            },
            pk="id",
            column_order=(
                "id",
                "statute_id",
                "order",
                "unit",
                "container",
            ),
            foreign_keys=["statute_id"],
        )
    return db
