from enum import Enum

dups = (
    lambda identifier: f"""
    --sql
    SELECT
        d.id as decision_id,
        substr(d.origin, -5, 5) as origin_url_id,
        x.{identifier} as duplicate_{identifier}
    FROM
        decisions d
        JOIN {identifier}s x ON d.{identifier} = x.id
    WHERE
        d.{identifier} in (
            SELECT
                {identifier}
            FROM
                decisions
            WHERE
                {identifier} IS NOT NULL
            GROUP BY
                {identifier}
            HAVING
                COUNT({identifier}) > 1
        );
"""
)


class DuplicateCitations(Enum):

    duplicate_phils_in_decisions = dups("phil")

    duplicate_scras_in_decisions = dups("scra")

    duplicate_offgs_in_decisions = dups("offg")

    duplicate_dockets_in_decisions = dups("docket")

    @property
    def shortcut(self):
        return self.name, self.value
