from enum import Enum

popular = (
    lambda identifier: f"""
        --sql
        SELECT

            (
                SELECT
                    dcx.id
                FROM
                    Decisions AS dcx
                WHERE
                    dcx.{identifier} = cite.{identifier}
            ) AS cited_case_id,

            (
                SELECT
                    dcs.case_title
                FROM
                    Decisions AS dcs
                WHERE
                    dcs.{identifier} = cite.{identifier}
            ) AS cited_case_name,

            COUNT(
                DISTINCT(
                    cite.decision_id
                )
            ) AS num_inbound_citations_unique_decisions,

            (
                SELECT
                    x.{identifier}
                from
                    {identifier+"s"} AS x
                WHERE
                    x.id = cite.{identifier}
            ) AS citation,
            cite.{identifier}
        FROM
            Citations AS cite
        WHERE
            cite.{identifier} IS NOT NULL
        GROUP BY
            cite.{identifier}
        HAVING
            num_inbound_citations_unique_decisions > 3
        ORDER BY
            num_inbound_citations_unique_decisions DESC;
    """
)


class PopularCitations(Enum):

    most_cited_phil = popular("phil")

    most_cited_scra = popular("scra")

    most_cited_offg = popular("offg")

    most_cited_docket = popular("docket")

    @property
    def shortcut(self):
        return self.name, self.value
