# get citation rows
# from more than one decision
# where docket and scra columns are not null
# where the citation docket id = decision docket it
# if more than two decisions, can reasonably infer
# that the citation DOCKET refers to the decision DOCKET
# and thus the citation SCRA must be the same as the decision SCRA
scra_dockets = """--sql
    SELECT
        decisions.id decision_to_update,
        citations.scra scra_id_to_insert
    FROM decisions
        JOIN dockets ON decisions.docket = dockets.id
        JOIN citations ON dockets.id = citations.docket
    WHERE
        decisions.scra IS NULL AND
        citations.scra IS NOT NULL
    GROUP BY
        scra_id_to_insert
    HAVING
        COUNT(scra_id_to_insert) > 2;
    """

bulk_update_decision_scras = """--sql
    UPDATE
        decisions AS original
    SET scra = (
        SELECT
            x.scra_id_to_insert
        FROM
            citations_with_scra_dockets AS x
        WHERE
            x.decision_to_update = original.id
        );
    """
